//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2003, 06
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einführung in JTree


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen, mit toString
// Klick Ereignis
// Drei Schalter


import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.*;

import javax.swing.event.*;

import java.io.*;

import java.util.Vector;

public class Tree08 extends JFrame {

  JTree jTree1;
  private int _NewIndex=0;

  DefaultMutableTreeNode rootNode;


  DefaultTreeModel treeModel;
  TreePath RootPath;

  int _index;


  public Tree08() {
    this.setLocation(500,300);
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setSize(600, 300);
    setTitle("JTree 08. Beispiel");
    setGUI();
  }

   // wird vom Tree aufgerufen,
    // hier muesste man weitere Dialogfenster aufrufen
   public void CreateAktionFromTreeNode( int i ) {
    System.out.println("in Methode CreateAktionFromTreeNode, ID: "+i);
   }


  private void setGUI() {
    JPanel panel = new JPanel();
    JButton BnExpand = new JButton("Expand"); // Add
    JButton BnRemove = new JButton("Remove");
    JButton BnAddNode = new JButton("Add Node");
    JButton BnClear = new JButton("Clear");

    this.getContentPane().setLayout( new BorderLayout() );

    panel.setLayout( new FlowLayout() );

    // ------------------

    BnExpand.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnExpand_click();
      }
    });
    panel.add(BnExpand);
    BnExpand.setFont( new Font("Arial", Font.BOLD,22)  );

    BnRemove.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnRemove_click();
      }
    });
    panel.add(BnRemove);
    BnRemove.setFont( new Font("Arial", Font.BOLD,22)  );


    BnAddNode.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnAddNode_click();
      }
    });
    panel.add(BnAddNode);
    BnAddNode.setFont( new Font("Arial", Font.BOLD,22)  );



    BnClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BnClear_click();
      }
    });
    panel.add(BnClear);
    BnClear.setFont( new Font("Arial", Font.BOLD,22)  );

    //---------------------------------------
    rootNode = BuildTree();

    treeModel = new DefaultTreeModel(rootNode);
    jTree1 = new javax.swing.JTree(treeModel);  //  kein Root !!!
    jTree1.setFont( new Font("Arial", Font.BOLD,18)  );

    RootPath = jTree1.getSelectionPath();

    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    // jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
   //  SINGLE_TREE_SELECTION, CONTIGUOUS_TREE_SELECTION or DISCONTIGUOUS_TREE_SELECTION.

   jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTree1_mouseClicked(e);
      }
    });


    jTree1.setBorder(BorderFactory.createLineBorder(Color.black));
    jTree1.setToolTipText("ToolTipp");
    jTree1.setShowsRootHandles(true);

      // Horizontale Linien
    jTree1.putClientProperty("JTree.lineStyle","Horizontal");
      // Mit Linien zwischen den Knoten
    jTree1.putClientProperty("JTree.lineStyle","Angled");

    this.getContentPane().add(panel, BorderLayout.NORTH);
    this.getContentPane().add( new JScrollPane(jTree1) , BorderLayout.CENTER);

  }  // setGUI






  // ----------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode  Kn0;
    DefaultMutableTreeNode  Kn1;
    DefaultMutableTreeNode  Kn2;
    DefaultMutableTreeNode  Kn3;

    root = createCNode(  0,"root");  // new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Kn0 = createCNode(  1,"1. Stufe (1)");
    root.add( Kn0 );

    Kn1 = createCNode(  2,"AAA");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  3,"BBB");
    Kn0.add( Kn1 );  // Parameter Vater


    // ---------

    Kn0 = createCNode(  2,"1. Stufe (2)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"CCC");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  2,"DDDD");
    Kn0.add( Kn1 );  // Parameter Vater


    Kn0 = createCNode(  3,"1. Stufe (3)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"EEE");
    Kn0.add( Kn1 );  // Parameter Vater

      Kn2 = createCNode(  7,"E1E1E1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  2,"E2E2E2");
      Kn1.add( Kn2 );  // Parameter Vater

    Kn1 = createCNode(  11,"FFF");
    Kn0.add( Kn1 );  // Parameter Vater
      Kn2 = createCNode(  2,"F1F1F1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  4,"F2F2F2");
      Kn1.add( Kn2 );  // Parameter Vater

    return root;
  }  // BuildTree


 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNodeRec CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNodeRec(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    // Node = new DefaultMutableTreeNode(nodeString);
    //Node.setUserObject(CNode);
    return Node;
 }


 void jTree1_mouseClicked(MouseEvent e) {
    int selRow = jTree1.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = jTree1.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
       if(e.getClickCount() == 1) {
           SingleClick(selRow, selPath);
       }
       else if(e.getClickCount() == 2) {
           DoubleClick(selRow, selPath);
      }
    }
  }

  void  SingleClick(int selRow, TreePath selPath) {
    System.out.println("CSingleClick: "+selRow);
  }


   // Doppelklick, abpruefen ob ein echter Knoten
   // ID > 2, dann Aufruf CreateAktionFromTreeNode
 void  DoubleClick(int selRow, TreePath selPath) {
    DefaultMutableTreeNode node;
    CTreeNodeRec CNode;
    node = (DefaultMutableTreeNode) jTree1.getLastSelectedPathComponent();
    if (node == null) {
       return;
    }
    else {
      CNode = (CTreeNodeRec) node.getUserObject();
      System.out.println("CDoubleClick: "+node.toString()+" \n" +CNode.getData() );
      if ( CNode.getData()>2 ) {
	      // Aufruf und Erzeugen eines Dialogfensters
         CreateAktionFromTreeNode( CNode.getData() );
         setTitle("Data größer 2");
      }
      else {
        setTitle("Data kleiner gleich 2");
      }
    }
  }


   // Expand fuer alle Knoten
  void BnExpand_click() {
     // addNodes();
     //jTree1.expandPath( RootPath );
     //jTree1.expandRow(0);
      // Alle Knoten öffnen
    for (int i=0; i<jTree1.getRowCount(); i++) {
      jTree1.expandRow(i);
    }
  }

   // einfuegen eines Knoten am aktuellen Knoten
  void  BnAddNode_click() {
    TreePath currentSelection = jTree1.getSelectionPath();
    DefaultMutableTreeNode  Kn0;
    if (currentSelection != null) {
       DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                       (currentSelection.getLastPathComponent());
       DefaultMutableTreeNode parent = (DefaultMutableTreeNode)(currentNode.getParent());
       if (parent != null) {
         _NewIndex++;
         Kn0 = createCNode( _NewIndex,"Neuer Knoten "+ Integer.toString(_NewIndex));
         parent.add( Kn0 );
         jTree1.updateUI();
       }
       else  System.out.println("parent null");
      }
    else  System.out.println("curentselection == null");
  }  // BnAddNode_Click

  void BnRemove_click() {
    removeCurrentNode();
  }

  public void removeCurrentNode() {
      Toolkit toolkit = Toolkit.getDefaultToolkit();
      TreePath currentSelection = jTree1.getSelectionPath();
        toolkit.beep();
      if (currentSelection != null) {
          DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                       (currentSelection.getLastPathComponent());
          MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
          if (parent != null) {
              treeModel.removeNodeFromParent(currentNode);
              return;
          }
      }

      // Either there was no selection, or the root was selected.
      toolkit.beep();
  }


  void BnClear_click() {
     rootNode.removeAllChildren();
     treeModel.reload();
     // Invoke this method if you've modified the TreeNodes upon which this model depends.
     // The model will notify all of its listeners that the model has changed.
  }

  public static void main(String[] args) {
    Tree08 frame = new Tree08();
    frame.setVisible(true);
 }


}  // Tree08




// Einfache Klasse für jeden Knoten
class CTreeNodeRec  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;     // eigentliche Daten

    public String _nodeString;  // wie wird der Knoten dargestellt


   public CTreeNodeRec(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // für JTree;
      nr++;
      _id = nr;  // setzt eindeutige Nummer
   }


   public long getID() {
     return _id;
   }


   public int getData() {
     return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }
   
   // sehr wichtig
   public String toString() {
     return _nodeString;
   }
   

}  // CTreeNodeRec




